;    
;   
show_stage:
cpi stage,1  ; 1- 
breq set_1   ;   1- 
cpi stage,2  ; 2- 
breq set_2   ;   2- 
cpi stage,3
breq set_3
cpi stage,4
breq set_4
cpi stage,5
breq set_5
cpi stage,6
breq set_6
cpi stage,7
breq set_7
 set_1:               ; 1 
 ldi Rab1,0b11110111
 out PORTB,Rab1
 ret
 set_2:               ; 2 
 ldi Rab1,0b11100111
 out PORTB,Rab1
 ret
 set_3:               ; 3 
 ldi Rab1,0b11100110
 out PORTB,Rab1
 ret
 set_4:
 ldi Rab1,0b11100100
 out PORTB,Rab1
 ret
 set_5:
 ldi Rab1,0b11100000
 out PORTB,Rab1
 ret
 set_6:
 ldi Rab1,0b11000000
 out PORTB,Rab1
 ret
 set_7:
 ldi Rab1,0b10000000
 out PORTB,Rab1
 ret

;    
 show_first_position:
 cpi random_value,85
 brlo choose_1           ; .   85
 cpi random_value,170 
 brlo choose_2           ; ..  85  170
 brsh choose_3           ; ..  170
 choose_1:
 ldi status,$80  ; status , 
                 ;    1
 rjmp start_blink_led
 choose_2:
 ldi status,$88  ;  2
 rjmp start_blink_led
 choose_3:
 ldi status,$90  ;  3
 start_blink_led:  ;   
 ldi Chislo_Combination,5 ;5  
 blink_loop:
 sbrc status,4
 rjmp blink_3  ; status(4-3)=10
 sbrc status,3
 rjmp blink_2  ; status(4-3)=01 
  blink_1:
  ldi Rab1,0b11111110
  out PORTB,Rab1 ;   1
  rjmp pause
  blink_2:
  ldi Rab1,0b11111101
  out PORTB,Rab1 ;   2
  rjmp pause
  blink_3:
  ldi Rab1,0b11111011
  out PORTB,Rab1 ;   3
  pause:
  ldi Rab1,30    ;  0,3 
  mov Combination_period,Rab1
  rcall create_time_period ; 0,3 
  ser Rab1
  out PORTB,Rab1          ; 
  rcall create_time_period ; 0,3 c
 dec Chislo_Combination ;  
 cpi Chislo_Combination,0 ; 0  ,
                          ;  
 brne blink_loop 
 ret

;  
peremeshivanie:
;      
cpi stage,1  
breq set_1_stage
cpi stage,2
breq set_2_stage
cpi stage,3
breq set_3_stage  ; 3-    
                  ;   
				  ;   
cpi stage,4
breq set_4_stage
cpi stage,5
breq set_5_stage
cpi stage,6
breq set_6_stage
cpi stage,7
breq set_7_stage
set_1_stage:        ; 1-    
                    ;0.8     10
ldi Rab1,80
mov Combination_period,Rab1
ldi Chislo_Combination,10
rjmp create_combination
set_2_stage:
ldi Rab1,70
mov Combination_period,Rab1
ldi Chislo_Combination,13
rjmp create_combination
set_3_stage:
ldi Rab1,50
mov Combination_period,Rab1
ldi Chislo_Combination,16
rjmp create_combination
set_4_stage:
ldi Rab1,30
mov Combination_period,Rab1
ldi Chislo_Combination,19
rjmp create_combination
set_5_stage:
ldi Rab1,20
mov Combination_period,Rab1
ldi Chislo_Combination,22
rjmp create_combination
set_6_stage:
ldi Rab1,15
mov Combination_period,Rab1
ldi Chislo_Combination,25
rjmp create_combination
set_7_stage:
ldi Rab1,10
mov Combination_period,Rab1
ldi Chislo_Combination,28
       create_combination:
rcall random_generator ;   
                       ;   
	   mov Rab3,psevdo_random_value
;  .    
;     
	   cpi Rab3,42
	   brlo one_two       ;1 	   	      
	   cpi Rab3,84
	   brlo one_three     ;2 
	   cpi Rab3,126
	   brlo two_three     ;3 		  
       cpi Rab3,168
	   brlo one_two       ;4 
	   cpi Rab3,210
	   brlo three_one     ;5 
	   brsh two_three     ;6 

;   1   2, status==128
;   2   1, status==136
one_two:           
ldi Rab1,0b11111000
out PORTB,Rab1
rcall create_time_period
ldi Rab1,0b11010011
out PORTB,Rab1
rcall create_time_period
;   3-  -   
cpi status,144
breq end_shag   ; 
cpi status,136  ;  2- 
brne in_one_pole ;  1- 
ldi status,128  ;  1- 
rjmp end_shag   ; 
in_one_pole:    ;  2- 
ldi status,136
rjmp end_shag   ; 


;   3   2, status==144
;   2   3, status==136
two_three:          
ldi Rab1,0b11111000
out PORTB,Rab1
rcall create_time_period
ldi Rab1,0b10101110
out PORTB,Rab1
rcall create_time_period
;   1- ,    
cpi status,128   ;  1- 
breq end_shag    ; 
cpi status,136   ;  2- 
brne in_two_pole ;  3- 
ldi status,144   ;  3- 
rjmp end_shag    ; 
in_two_pole:
ldi status,136   ;  3- 
rjmp end_shag    ; 

;   1   3
one_three:          
ldi Rab1,0b11111000
out PORTB,Rab1
rcall create_time_period
ldi Rab1,0b10110101
out PORTB,Rab1
rcall create_time_period
ldi Rab1,0b11001101
out PORTB,Rab1
rcall create_time_period
;   2- ,    
cpi status,136     ;  2- 
breq end_shag      ; 
cpi status,128     ;  1- 
brne in_three_pole ;  3- 
ldi status,144     ;  3- 
rjmp end_shag      ; 
in_three_pole:
ldi status,128     ;  1- 
rjmp end_shag

;   3   1
three_one:           
ldi Rab1,0b11111000
out PORTB,Rab1
rcall create_time_period
ldi Rab1,0b11001101
out PORTB,Rab1
rcall create_time_period
ldi Rab1,0b10110101
out PORTB,Rab1
rcall create_time_period
;   2- ,    
cpi status,136     ;  2- 
breq end_shag      ; 
cpi status,128     ;  1- 
brne in_three_pole2 ;  3- 
ldi status,144     ;  3- 
rjmp end_shag      ; 
in_three_pole2:
ldi status,128     ;  1- 
rjmp end_shag

end_shag:
dec Chislo_Combination    ;  
                          ;
cpi Chislo_Combination,0  ;   0
breq end_peremeshivanie   ; 0,   
rjmp create_combination   ;  
end_peremeshivanie:
ldi Rab1,0b11111000
out PORTB,Rab1
rcall create_time_period
ser Rab1
out PORTB,Rab1
ret

;   
right_choose:
cbi PORTB,7           ;  
 cpi random_value,130 ;  1 - 128
 brlo setr_1
 cpi random_value,140 ;  2 - 136
 brlo setr_2
 cbi PORTB,2          ; 3- - 144>130  
 rjmp end_right_choose
 setr_1:
 cbi PORTB,0          ; 1- 
 rjmp end_right_choose
 setr_2:
 cbi PORTB,1          ; 2- 
 rjmp end_right_choose
 end_right_choose:
ret 

;   
wrong_choose:
cbi PORTD,6           ;  
                      ; 
;  .
; -    
rcall show_first_position 
;  ,    
;r30    
 cpi r30,130
 brlo setw_1            ;<130 .. 1  -  128
 cpi r30,140
 brlo setw_2            ;2  -  136 < 140
 cbi PORTB,2            ; 3-
 rjmp end_wrong_choose
 setw_1:
 cbi PORTB,0            ; 1-
 rjmp end_wrong_choose
 setw_2:
 cbi PORTB,1            ; 2-
 rjmp end_wrong_choose
 end_wrong_choose:
ret
