;   " "
;:  
;: 1.0
; : 8  2009 
; : 2009 

.include "tn2313def.inc"
.CSEG
.def Rab1=r16             ;  1
.def Rab2=r17             ;  2
.def Rab3=r18             ;  3
.def Rab4=r19             ;  4
.def Rab5=r20             ;  5
.def random_value=r21     ;   
.def Combination_period=r14;,  
                  ; ( )
.def stage=r22            ;  
                          ; 
.def status=r25           ;-
.def Chislo_Combination=r24 ;  
;    
.def c=r1
.def x0=r2
.def a=r3
.def psevdo_random_value=r4			  				   
.org 0
rjmp RESET
rjmp EXT_INTO            
nop ;rjmp EXT_INT1
nop ;rjmp TIM_CAPT1
nop ;rjmp TIM_COMP1
nop ;rjmp TIM_OVF1
rjmp TIM_OVF0            
nop ;rjmp UART_RXC
nop ;rjmp UART_DRE
nop ;rjmp UART_TXC
nop ;rjmp ANA_COMP
nop ;rjmp PCINT
nop ;rjmp TIMER1 COMPB
nop ;rjmp TIMER0 COMPA 
nop ;rjmp TIMER0 COMPB
nop ;rjmp USI START
nop ;rjmp USI OVERFLOW 
nop ;rjmp EE READY
nop ;rjmp WDT OVERFLOW

.include "Interrupt.asm"

RESET:
ldi Rab1,low(RAMEND)   ; 
out SPL,Rab1
ser Rab1              
out PORTB,Rab1         ;  A,B . 1
out PORTA,Rab1
clr Rab1
mov status,Rab1        ;status=0
ldi Rab1,0b01111111    ; .  D
out PORTD,Rab1

ser Rab1
out DDRB,Rab1          ; B  
ldi Rab1,0b01000000    ;  D 
out DDRD,Rab1
ldi Rab1,$3            ;  A  
out DDRA,Rab1          ; 4  5  

ldi Rab1,15            ;   2 
out WDTCR,Rab1

                       
ldi Rab1,$3            ; TIM0 c f/64 
out TCCR0,Rab1
ldi Rab1,$0
out TCNT0,Rab1         ;    TIM0 - 0 

ldi Rab1,$82
out TIMSK,Rab1         ;    
ldi Rab1,$40           ;   INT0  
out GIMSK,Rab1

;    
; EEPROM   0x00
ldi Rab1,1
mov c,Rab1
mov x0,Rab1
  clr Rab1
  out EEAR,Rab1 ;   0  EEPROM
  sbi EECR,EERE ;  
  in stage,EEDR ;   Stage
  cpi stage,255  ; 1- ,  
                ;
  breq set_ini_stage ;  
           ;  
           ;  
            cpi stage,8
			;  1-7
			brlo set_end_read_EEPROM 
			;  1 
			;    
    set_ini_stage:
	ldi stage,1
	cbi EECR,EERE  ;  
	out EEDR,stage ;      
	sbi EECR,EEMPE ;  EEMWE
	sbi EECR,EEPE  ;  EEPROM
	set_end_read_EEPROM:
rcall show_stage       ;   
ldi Rab1,150            
mov Combination_period,Rab1 ;1.5 - 
                            ; 
rcall create_time_period  ;
ser Rab1
out PORTB,Rab1 
sei                    ; 
;***********MAIN**************************
main:
wdr                    ; 
sbrc status,7
rcall start_game       ; 
sbis PIND,0
rcall plus_button    ;   
sbis PIND,1
rcall minus_button   ;   
rjmp  main

;**************Functions*******************
;  
start_game:
sbi PORTB,7   ;   
sbi PORTD,6
;   
rcall show_first_position
; 
rcall peremeshivanie
;  
rcall analiz_answer 
sbrc status,0
rcall wrong_choose ;  
sbrc status,1
rcall right_choose ;  
clr status
ldi Rab1,$40       ;   INT0  
out GIMSK,Rab1
ret
.include "Combination.asm"
.include "Time_Interval.asm"
.include "random_generation.asm"
.include "button_analiz.asm"
.exit
	
